unit ApiType;

interface

uses Windows, Forms, OpenGL, Graphics, Sysutils, Classes;

const
  { }
  cmNone        = 0;
  cmVisyach     = 1;
  cmWOPrimRound = 2;
  cmKoordPriv   = 3;
  cmRazomknut   = 4;
  cmZamknut     = 5;
  cmSomknut     = 6;
  cmNoneWork    = 7; // ,    

  {  }
  evCreateMap       = 01;
  evOpenMap         = 02;
  evSaveMap         = 03;
  evBeforePrintDoc  = 10;
  evBeforeDesignDoc = 11;
  evBeforeEditDoc   = 12;

type
  {    Double - }
  TDoublePoint = record
    x  : Double;
    y  : Double;
  end;

  {    Double -  +  + KO}
  TGeoPoint = record
    x  : Double;  y  : Double;  h  : Double;
    mx : Double;  my : Double;  mh : Double;
  end;

  {    }
  TIntArray = array of Integer;
  TGeoPointArray = array of TGeoPoint;

  {    }
  TPicket = record
    ID : Integer;
    Name : String[16];
    Metric : TGeoPoint;
    Visible : Boolean;
  end;
  TPicketArray = array of TPicket;

  {   }
  PMapPicket = ^TMapPicket;
  TMapPicket = record
    ID : Integer;
    Name : String[16];
    Metric : TGeoPoint;
    Visible : Boolean;
    Select : Boolean;
  end;


  {   }
  TRasterList = record
    GL : GLint;
    SW, NE : TDoublePoint;
    Visible : Boolean;
  end;

  {   }
  TRasterPack  = record
    Pages : array of TRasterList;
    Name : String;
    RasterVisible : Boolean;
  end;

  {   }
  TNeighbour = record
    nObjCode : Integer;
    nMetric : array of TDoublePoint;
    nB1, nB2 : String;
  end;
  TNeighbours = array of TNeighbour;

  {      }
  TMetricRect = record
    North, East, South, West : Double;
  end;

  {     }
  TSampleSemantic = record
    Code : Word;                 //-     
    DefaultValue : String[200];  //- 
  end;
  TSemanticArray = array of TSampleSemantic;


//========================================================================================

  {    }
  PMapObject = ^TMapObject;
  TMapObject = record
    GL          : GLInt;          //-   OpenGL
    ID          : Integer;        //-      
    Parent      : Integer;        //-    
    Local       : Byte;           //-  
    ScriptCode  : Integer;        //-     
    DataCreate  : TDateTime;      //-   
    Frame       : TMetricRect;    //-    
    Metric      : TGeoPointArray; //-     
    Semantic    : TSemanticArray; //-   
  end;
  TMapObjectArray = array of TMapObject;

  {   }
  TMapPassport = record
    Name : String[200];           //-  
    Default : String[100];        //-  (  )
    ScriptName : String[60];      //-   
    Comment : String[250];        //- 
    Scale : Double;               //-  
    NorthWest, NorthEast, SouthWest, SouthEast : TDoublePoint;
    UseFrame, AngleFrame : Boolean;
  end;


//======= -  ===========================================================

  {     - }
  TLAKatalogLine = record
    StationPicketName, VisingPicketName : String[18];
    Angle, Direction, Prevish, VertAngle, InstrI, InstrV,
    Line, Dx, Dy, X, Y, H : Double;
  end;

  {  - }
  TLineAngleMagazineSample = record
    ID           : Integer;
    MagazineName : String[60];    //-  
    AreaWorks    : String[60];    //-  
    Weather      : String[40];    //- 
    DateCreate   : TDateTime;     //-   
    MagazineMode : Byte;          //-   
    KatalogLines : array of TLAKatalogLine;
    LASource     : TPicketArray;
  end;


//=======  =================================================================

  {     }
  TTeoKatalogLine = record
    PicketName : String[18];
    Angle, fAngle, Direction, Line, VertAngle, InstrI, InstrV,
    Prevish, fPrevish, Dx, Dy, fDx, fDy, X, Y, H : Double;
    Stativs : Word;
  end;

  {  }
  TTeoCourse = record
    Picket1, Picket2, Picket3, Picket4 : String[18];
    CourseMode   : Byte;          //-  
    KatalogLines : array of TTeoKatalogLine;
    // 
    fAngle         : Double;      //-  
    fAngleDopusk   : Double;      //-   
    Perimetr       : Double;      //-  
    Fx, Fy         : Double;      //-   
    fLine          : Double;      //-  
    fOLine         : Double;      //-   
    LinDopusk      : Double;      //-   
    fSumPrevish    : Double;      //-   
    fPrevishDopusk : Double;      //- o   
  end;

  {   }
  TTeoMagazineSample = record
    ID           : Integer;
    MagazineName : String[60];    //-  
    AreaWorks    : String[60];    //-  
    Weather      : String[40];    //- 
    DateCreate   : TDateTime;     //-   
    MagazineMode : Byte;          //-   
    NetKlass     : Byte;          //-  
    NivelirShema : Byte;          //-    
    NivelirNev   : Byte;          //-    
    Courses      : array of TTeoCourse;
    TESource     : TPicketArray;
  end;


//========================================================================================

  {     }
  TEventProc = procedure(EventMode : Integer; Param : string) of object;

  {API - }
  TPluginInterface = class
  public
    //    
    procedure gisRegisterEvent(Proc : TEventProc); virtual; stdcall; abstract;

    //  ,  
    procedure gisCreateAction(atCaption, atHint: String; atGlyph: TBitmap; atProc: TNotifyEvent; var resName: String); virtual; stdcall; abstract;
    procedure gisCreateToolBar(tbCaption: String; var resName: String); virtual; stdcall; abstract;
    procedure gisCreateToolBtn(barName, atName: String; var resName: String); virtual; stdcall; abstract;
    procedure gisCreateMenuBtn(mnuName, atName: String; mnuLevel: Integer; mnuGlyph: Boolean; var resName: String); virtual; stdcall; abstract;
    procedure gisCreateSubMenu(mnuName, subCaption: String; mnuLevel: Integer; var resName: String); virtual; stdcall; abstract;

    //    
    function gisApplication : TApplication; virtual; stdcall; abstract;
    function gisMapCount : Integer; virtual; stdcall; abstract;
    function gisMapExists : Boolean; virtual; stdcall; abstract;
    procedure gisMapToPixel(const mx, my : Double; var px, py: Integer); virtual; stdcall; abstract;
    procedure gisPixelToMap(const px, py : Double; var mx, my: Double); virtual; stdcall; abstract;
    function gisSaveMapToGisFile(var Path : String) : Integer; virtual; stdcall; abstract;
    function gisLoadMapFromGisFile(Path : String) : Integer; virtual; stdcall; abstract;

    function gisFindParentForObject(ObjNumber : Integer) : Integer; virtual; stdcall; abstract;
    function gisGetObjectCodeForNumber(Value : Integer) : Integer; virtual; stdcall; abstract;
    function gisGetObjectNumberForCode(Value : Integer) : Integer; virtual; stdcall; abstract;
    function gisGetObjectForNumber(Value : Integer; var ObjInfo : TMapObject) : Boolean; virtual; stdcall; abstract;
    function gisGetObjectForCode(Value : Integer; var ObjInfo : TMapObject) : Boolean; virtual; stdcall; abstract;
    function gisGetRasterForNumber(Value : Integer; var RST : TRasterPack) : Boolean; virtual; stdcall; abstract;
    procedure gisSetVisibleRaster(Index : Integer; Value : Boolean); virtual; stdcall; abstract;
    procedure gisSetDisplayRect(aRect : TRect); virtual; stdcall; abstract;
    procedure gisRegenerateVisualLists; virtual; stdcall; abstract;
    procedure gisSetParentForObject(ObjCode, Parent : Integer); virtual; stdcall; abstract;

    function gisSelectObjectsCount : Integer; virtual; stdcall; abstract;
    function gisGetSelectCodeForNumber(Value: Integer) : Integer; virtual; stdcall; abstract;
    procedure gisMapRefresh; virtual; stdcall; abstract;
    procedure gisSetProgress(Value: Word; fgColor: Integer); virtual; stdcall; abstract;

    function gisGetPicketCodeForNumber(Value : Integer) : Integer; virtual; stdcall; abstract;
    function gisGetPicketNumberForCode(Value : Integer) : Integer; virtual; stdcall; abstract;
    function gisGetPicketForNumber(Value : Integer; var PickInfo : TMapPicket) : Boolean; virtual; stdcall; abstract;
    function gisGetPicketForCode(Value : Integer; var PickInfo : TMapPicket) : Boolean; virtual; stdcall; abstract;
    function gisCreateNewPicket(aName : String; aMetric : TGeoPoint) : Integer; virtual; stdcall; abstract;
    procedure gisDeletePicketForNumber(Value : Integer); virtual; stdcall; abstract;
    procedure gisDeletePicketForCode(Value : Integer); virtual; stdcall; abstract;
    procedure gisDeleteSelectPickets; virtual; stdcall; abstract;
    procedure gisUpdatePicket(PickInfo : TMapPicket); virtual; stdcall; abstract;

    function gisObjectExistForCode(ObjCode : Integer) : Boolean; virtual; stdcall; abstract;
    function gisCreateNewObject(SampleCode : Integer; aMetric : TGeoPointArray) : Integer; virtual; stdcall; abstract;
    function gisAppendObject(ObjInfo : TMapObject) : Integer; virtual; stdcall; abstract;
    function gisUpdateObject(ObjInfo : TMapObject) : Integer; virtual; stdcall; abstract;
    procedure gisDeleteObjectForCode(ObjCode : Integer); virtual; stdcall; abstract;

    function gisGetOnlyChildCount(ObjCode: Integer): Integer; virtual; stdcall; abstract;
    procedure gisGetAllChildObjects(ObjCode : Integer; var Childs: TIntArray); virtual; stdcall; abstract;
    procedure gisGetAllChildChildObjects(ObjCode : Integer; var Childs: TIntArray); virtual; stdcall; abstract;
    function gisGenerateNeighbours(const ObjCode: Integer; Laureate: TIntArray; var Neig: TNeighbours): Boolean; virtual; stdcall; abstract;
    procedure gisAppendRaster(FileName : String); virtual; stdcall; abstract;
    procedure gisDeleteRaster(RasterNumber : Integer); virtual; stdcall; abstract;

    procedure gisGetLAMagazine(Number : Integer; var Magazine : TLineAngleMagazineSample); virtual; stdcall; abstract;
    procedure gisGetTEMagazine(Number : Integer; var Magazine : TTeoMagazineSample); virtual; stdcall; abstract;
    function gisAppendLAMagazine(Value : TLineAngleMagazineSample; Number : Integer) : Integer; virtual; stdcall; abstract;
    function gisAppendTEMagazine(Value : TTeoMagazineSample; Number : Integer) : Integer; virtual; stdcall; abstract;
    procedure gisDeleteLAMagazine(Number : Integer); virtual; stdcall; abstract;
    procedure gisDeleteTEMagazine(Number : Integer); virtual; stdcall; abstract;

    function gisGetUserName : String; virtual; stdcall; abstract;
    procedure gisMapLayersFull; virtual; stdcall; abstract;
    function gisSortObjects(ckFull : Boolean) : Integer; virtual; stdcall; abstract;
    function gisNeedSorted : Boolean; virtual; stdcall; abstract;
    function gisSelectFramePickets(N,S,W,E : Double; UnSum : Boolean) : Boolean; virtual; stdcall; abstract;

    procedure gisProjectFrame(pmRect : TMetricRect); virtual; stdcall; abstract;
    procedure gisGetMapPassport(var Passport : TMapPassport); virtual; stdcall; abstract;
    procedure gisSetMapPassport(Passport : TMapPassport); virtual; stdcall; abstract;
    procedure gisPointView(Value : Boolean); virtual; stdcall; abstract;
    function gisObjectCount : Integer; virtual; stdcall; abstract;
    function gisRasterCount : Integer; virtual; stdcall; abstract;
    function gisPicketCount : Integer; virtual; stdcall; abstract;
    function gisPicketSelectCount : Integer; virtual; stdcall; abstract;
    function gisLAMagCount : Integer; virtual; stdcall; abstract;
    function gisTEMagCount : Integer; virtual; stdcall; abstract;
    function gisFrameNorth : Double; virtual; stdcall; abstract;
    function gisFrameSouth : Double; virtual; stdcall; abstract;
    function gisFrameWest : Double; virtual; stdcall; abstract;
    function gisFrameEast : Double; virtual; stdcall; abstract;
    procedure gisGetMapAlphaValue(var aValue : Single); virtual; stdcall; abstract;
    procedure gisSetMapAlphaValue(aValue : Single); virtual; stdcall; abstract;
    procedure gisGetProjectFileName(var FileName : String); virtual; stdcall; abstract;
    procedure gisSetProjectFileName(FileName : String); virtual; stdcall; abstract;
    procedure gisPrintViewMode(Value : Boolean); virtual; stdcall; abstract;
    function gisFileVersion : Integer; virtual; stdcall; abstract;

    procedure gisCorrectContur(var Contur : TGeoPointArray); virtual; stdcall; abstract;
    function gisSquare (Contur : TGeoPointArray; Decimal : Byte) : Double; virtual; stdcall; abstract;
    function gisPerimeter (Contur : TGeoPointArray) : Double; virtual; stdcall; abstract;
    function gisUgol_3k (t1, t2, t3 : TDoublePoint) : Double; virtual; stdcall; abstract;
    function gisDirection(Xn, Yn, Xk, Yk : Double) : Double; virtual; stdcall; abstract;
  end;


implementation

end.
