library Test_01;

uses
  Graphics,
  ApiType in 'ApiType.pas',
  WorkUnit in 'WorkUnit.pas';

{$R *.res}
{$R glyphs.res}


{ }
procedure InitPlugin(PlugClass: TPluginInterface);
var
  GlyphBmp : TBitmap;
  ActName, MnuName, BarName, BtnName : String;
begin
  IPlugin := PlugClass;
  WorkModule := TWorkModule.Create;
  ActName := ''; MnuName:= ''; BarName:= ''; BtnName:= '';

  GlyphBmp := TBitmap.Create;
  try
    GlyphBmp.LoadFromResourceName(hInstance, 'MYGLYPH');
    PlugClass.gisCreateAction(' ', ' ', GlyphBmp, WorkModule.ShowTime, ActName);
  finally
  GlyphBmp.Free;
  end;

  if ActName <> '' then
  begin
    // 
    PlugClass.gisCreateToolBar(' ', BarName);
    //   
    if BarName <> '' then
    PlugClass.gisCreateToolBtn(BarName, ActName, BtnName);
    //  
    PlugClass.gisCreateMenuBtn('MenuProject', ActName, 1, true, MnuName);
  end;
end;


{ }
procedure DestroyPlugin;
begin
  if Assigned(WorkModule) then WorkModule.Free;
end;


exports
  InitPlugin,
  DestroyPlugin;


begin
end.
